mod adder;
mod multiplier;
mod gray_code;
mod boolean_evaluation;
mod truth_table;
mod ast;

use gray_code::gray_code;
use truth_table::print_truth_table;
use boolean_evaluation::eval_formula;

fn main() {
    println!("Hello, world!");
    println!("{}", gray_code(4_294_967_295));
    println!("{}", gray_code(511));
    println!("{}", gray_code(255));
    println!("{}", gray_code(127));
    println!("{}", gray_code(63));
    println!("{}", gray_code(31));
    println!("{}", gray_code(15));
    println!("{}", gray_code(7));
    println!("{}", gray_code(3));
    print_truth_table("ABC|&");
    //print_truth_table("ABCF&&&");
    // println!("{}", eval_formula("000|&"));
    // println!("{}", eval_formula("001|&"));
    // println!("{}", eval_formula("010|&"));
    // println!("{}", eval_formula("011|&"));
    // println!("{}", eval_formula("100|&"));
    // println!("{}", eval_formula("101|&"));
    // println!("{}", eval_formula("110|&"));
    // println!("{}", eval_formula("111|&"));
}
