#[cfg(test)]
mod tests {
    use crate::truth_table::print_truth_table;

    #[test]
    fn only_binary() {
        print_truth_table("AB&");
        print_truth_table("AB|");
        print_truth_table("AB>");
        print_truth_table("AB=");
        print_truth_table("ABCD||=");
    }

    #[test]
    fn only_unary() {
        print_truth_table("A!");
    }

    #[test]
    fn binary_and_uneray() {
        print_truth_table("AB&!");
    }

    #[test]
    fn big() {
        //print_truth_table("AB&CD&&EF&GH&&&IJ&KL&&MN&OP&&&QR&ST&&UV&WX&&&YZ&&&")
    }
}
